## graphite2 1.1.3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
cmake_policy(SET CMP0012 NEW)
include(TestBigEndian)

project(graphite2)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})
if (NOT CMAKE_BUILD_TYPE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
endif (NOT CMAKE_BUILD_TYPE)

enable_language(CXX C)

include_directories(${PROJECT_SOURCE_DIR}/include)

enable_testing()

set(GRAPHITE2_VM_TYPE auto CACHE STRING "Choose the type of vm machine: Auto, Direct or Call.")
option(GRAPHITE2_NSEGCACHE "Compile out the gr_*_with_seg_cache APIs")
option(GRAPHITE2_NFILEFACE "Compile out the gr_make_file_face* APIs")
option(GRAPHITE2_NTRACING "Compile out log segment tracing capability")


message(STATUS "Build: " ${CMAKE_BUILD_TYPE})
string(REPLACE "ON" "disabled" _SEGCACHE_SUPPORT ${GRAPHITE2_NSEGCACHE})
string(REPLACE "OFF" "enabled" _SEGCACHE_SUPPORT ${_SEGCACHE_SUPPORT})
string(REPLACE "ON" "disabled" _FILEFACE_SUPPORT ${GRAPHITE2_NFILEFACE})
string(REPLACE "OFF" "enabled" _FILEFACE_SUPPORT ${_FILEFACE_SUPPORT})
string(REPLACE "ON" "disabled" _TRACING_SUPPORT ${GRAPHITE2_NTRACING})
string(REPLACE "OFF" "enabled" _TRACING_SUPPORT ${_TRACING_SUPPORT})
message(STATUS "Segment Cache support: " ${_SEGCACHE_SUPPORT})
message(STATUS "File Face support: " ${_FILEFACE_SUPPORT})
message(STATUS "Tracing support: " ${_TRACING_SUPPORT})

string(TOLOWER ${GRAPHITE2_VM_TYPE} GRAPHITE2_VM_TYPE)
if (NOT GRAPHITE2_VM_TYPE MATCHES "auto|direct|call")
    message(SEND_ERROR "unrecognised vm machine type: ${GRAPHITE2_VM_TYPE}. Only Auto, Direct or Call are available")
endif (NOT GRAPHITE2_VM_TYPE MATCHES "auto|direct|call")
if (GRAPHITE2_VM_TYPE STREQUAL "auto")
    if (CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
        set(GRAPHITE2_VM_TYPE "direct")
    else(CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
        set(GRAPHITE2_VM_TYPE "call")
    endif(CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
endif (GRAPHITE2_VM_TYPE STREQUAL "auto")
if (GRAPHITE2_VM_TYPE STREQUAL "direct" AND NOT (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_BASE_NAME STREQUAL "clang++"))
    message(WARNING "vm machine type direct can only be built using GCC")
    set(GRAPHITE2_VM_TYPE "call")
endif (GRAPHITE2_VM_TYPE STREQUAL "direct" AND NOT (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_BASE_NAME STREQUAL "clang++"))
message(STATUS "Using vm machine type: ${GRAPHITE2_VM_TYPE}")


add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(doc)
if (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
    add_subdirectory(gr2fonttest)
endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))

set(version 2.1.0)
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(includedir ${CMAKE_INSTALL_PREFIX}/include)

configure_file(graphite2.pc.in graphite2.pc)

install(FILES ${PROJECT_BINARY_DIR}/graphite2.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== gr2fonttest/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

project(gr2fonttest)

enable_testing()

include_directories(${PROJECT_SOURCE_DIR})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

add_executable(gr2fonttest gr2FontTest.cpp UtfCodec.cpp)
target_link_libraries(gr2fonttest graphite2)

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    # -lgcc LINKER_LANGUAGE C
    add_definitions(-fno-rtti -fno-exceptions)
    set_target_properties(gr2fonttest PROPERTIES LINK_FLAGS "-nodefaultlibs" LINKER_LANGUAGE C)
    set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
    # This script just fails
    nolib_test(stdc++ $<TARGET_FILE:gr2fonttest>)
endif  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

# copy the DLL so that gr2fonttest can find it
add_custom_target(${PROJECT_NAME}_copy_dll ALL 
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})

add_dependencies(${PROJECT_NAME}_copy_dll graphite2 gr2fonttest)

install(TARGETS gr2fonttest EXPORT gr2fonttest RUNTIME DESTINATION bin)

=== tests/CMakeLists.txt ===
project(testing)
include(Graphite)
include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(GRAPHITE2_COMPARE_RENDERER "Build tool to compare output of different renderers" OFF
                        "NOT GRAPHITE2_NFILEFACE;NOT GRAPHITE2_NSEGCACHE" OFF)

include_directories(${graphite2_core_SOURCE_DIR})
set(S ${graphite2_core_SOURCE_DIR})

add_library(graphite2-base STATIC
    ${S}/FeatureMap.cpp
    ${S}/NameTable.cpp
    ${S}/Sparse.cpp
    ${S}/TtfUtil.cpp
    ${S}/UtfCodec.cpp)

add_library(graphite2-segcache STATIC
    ${S}/GlyphFaceCache.cpp
    ${S}/GlyphFace.cpp
    ${S}/gr_logging.cpp
    ${S}/json.cpp
    ${S}/SegCache.cpp
    ${S}/SegCacheEntry.cpp
    ${S}/SegCacheStore.cpp
    ${S}/Slot.cpp)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set_target_properties(graphite2-base PROPERTIES 
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC _SCL_SECURE_NO_WARNINGS _CRT_SECURE_NO_WARNINGS UNICODE")
    set_target_properties(graphite2-segcache PROPERTIES 
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC _SCL_SECURE_NO_WARNINGS _CRT_SECURE_NO_WARNINGS UNICODE")
else (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set_target_properties(graphite2-base PROPERTIES 
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
    set_target_properties(graphite2-segcache PROPERTIES 
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

if (GRAPHITE2_COMPARE_RENDERER)
    add_subdirectory(comparerenderer)
endif (GRAPHITE2_COMPARE_RENDERER)
add_subdirectory(endian)
if (NOT GRAPHITE2_NFILEFACE)
    add_subdirectory(examples)
endif (NOT GRAPHITE2_NFILEFACE)
add_subdirectory(featuremap)
add_subdirectory(grlist)
add_subdirectory(json)
add_subdirectory(nametabletest)
if (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
    add_subdirectory(segcache)
endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
add_subdirectory(utftest)
if (NOT GRAPHITE2_NFILEFACE)
    add_subdirectory(vm)
endif (NOT GRAPHITE2_NFILEFACE)

enable_testing()

fonttest(padauk1 Padauk.ttf 1015 102F 100F 1039 100F 1031 1038)
fonttest(padauk2 Padauk.ttf 1000 103C 102D 102F)
fonttest(padauk3 Padauk.ttf 101e 1004 103a 1039 1001 103b 102d 102f 1004 103a 1038)
fonttest(padauk4 Padauk.ttf 1005 1000 1039 1000 1030)
fonttest(padauk5 Padauk.ttf 1000 103c 1031 102c 1004 1037 103a)
fonttest(padauk6 Padauk.ttf 1000 102D 1005 1039 1006 102C)
# padauk7 can cause an infinite loop, though the text is miss-spelt
fonttest(padauk7 Padauk.ttf 1017 1014 103c 103d 102f)
fonttest(padauk8 Padauk.ttf 1004 103A 1039 1005)
fonttest(padauk9 Padauk.ttf 1004 103A 1039)
fonttest(padauk10 Padauk.ttf 1004 103D 1000 103A -feat kdot=1,wtri=1)
fonttest(padauk11 Padauk.ttf 100B 1039 100C 1031 102C)
fonttest(scher1 Scheherazadegr.ttf 0628 0628 064E 0644 064E 0654 0627 064E -rtl)
fonttest(scher2 Scheherazadegr.ttf 0627 0644 0625 0639 0644 0627 0646 -rtl)
fonttest(scher3 Scheherazadegr.ttf 0627 0031 0032 002D 0034 0035 0627 -rtl)
fonttest(charis1 charis_r_gr.ttf 0069 02E6 02E8 02E5)
fonttest(charis2 charis_r_gr.ttf 1D510 0041 1D513)
fonttest(charis3 charis_r_gr.ttf 0054 0069 1ec3 0075 -feat 'lang=vie')
fonttest(charis4 charis_r_gr.ttf 006b 0361 070)
fonttest(charis5 charis_r_gr.ttf 0020 006C 0325 0065)
fonttest(magyar1 MagyarLinLibertineG.ttf 0031 0035 -feat 210=36)
fonttest(magyar2 MagyarLinLibertineG.ttf 0031 0030 -feat 210=200)
fonttest(magyar3 MagyarLinLibertineG.ttf 0066 0069 0066 0074 0079 002d 0066 0069 0076 0065 -feat 209=3)
fonttest(grtest1 grtest1gr.ttf 0062 0061 0061 0061 0061 0061 0061 0062 0061)
fonttest(general1 general.ttf 0E01 0062)

feattest(padauk_feat Padauk.ttf)
feattest(charis_feat charis_r_gr.ttf)
feattest(scher_feat Scheherazadegr.ttf)

=== tests/comparerenderer/CMakeLists.txt ===
project(comparerenderer)

find_path(ICU_INCLUDE NAMES unicode/utypes.h 
	PATHS /usr/local/include /usr/include ${PROJECT_SOURCE_DIR}/../../../icu/source/common
	DOC "Include directory for the ICU library")
find_path(ICU_LAYOUT_INCLUDE NAMES layout/LETypes.h
	PATHS /usr/local/include /usr/include ${PROJECT_SOURCE_DIR}/../../../icu/source
	DOC "Include directory for the ICU layout engine")
find_path(ICU_LIBRARY_PATH NAMES icuuc${CMAKE_LINK_LIBRARY_SUFFIX} 
	${CMAKE_SHARED_LIBRARY_PREFIX}icuuc${CMAKE_SHARED_LIBRARY_SUFFIX} cygicuuc cygicuuc32
	PATHS /usr/local/lib /usr/lib ${PROJECT_SOURCE_DIR}/../../../icu/source/lib
	DOC "Libraries to link against for the common parts of ICU")

set(ICULE)
if (${ICU_INCLUDE} STREQUAL "ICU_INCLUDE-NOTFOUND")
	set(ICU_FOUND 0)
	set(ICU_INCLUDE_DIRS) 
	set(ICU_LDFLAGS)
	set(ICU_LIBRARY_PATH)
else (${ICU_INCLUDE} STREQUAL "ICU_INCLUDE-NOTFOUND")
    set(ICU_FOUND 1)
    file(GLOB ICULE icule/*.cpp icule/*.h)
    add_definitions(-DHAVE_ICU)
    set(ICU_INCLUDE_DIRS "${ICU_INCLUDE}" "${ICU_LAYOUT_INCLUDE}")
    link_directories(${ICU_LIBRARY_PATH})
    if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
        set(ICU_LDFLAGS icule icuuc icudt)
    else (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
        set(ICU_LDFLAGS icule icuuc icudata)
    endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
endif (${ICU_INCLUDE} STREQUAL "ICU_INCLUDE-NOTFOUND")

#find_path(HB1_INCLUDE NAMES "harfbuzz-shaper.h"
#        PATHS /usr/local/include/harfbuzz-1 /usr/include/harfbuzz-1
#        DOC "Include directory for harfbuzz")
#if (NOT ${HB1_INCLUDE} STREQUAL "")
#    add_definitions(-DHAVE_HARFBUZZ)
#    set(HB1_LDFLAGS "-L${HB1_INCLUDE}/../../lib -lharfbuzz-1")
#endif (${HB1_INCLUDE})

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    find_package(Freetype)
    find_package(PkgConfig)

    pkg_check_modules(GR silgraphite)
    pkg_check_modules(HB harfbuzz)
    pkg_check_modules(GLIB glib-2.0)
    # pkg_check_modules(GRNG graphite)

    if (${HB_FOUND})
        if (${FREETYPE_FOUND})
            add_definitions(-DHAVE_HARFBUZZNG)
        endif (${FREETYPE_FOUND})
    endif (${HB_FOUND})

    if (${GR_FOUND})
        add_definitions(-DHAVE_GRAPHITE)
        set(GR_EXTRA_SOURCE GrUtfTextSrc.cpp)
    endif (${GR_FOUND})
    set(RT_LDFLAGS "rt")

endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	find_path(GR_INCLUDE graphite/GrClient.h PATHS ENV SILGRAPHITE_HOME ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.3.1 ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.4.0 ${GRAPHITE_INSTALLED_PATH} ${PROJECT_SOURCE_DIR}/../../../graphite-trunk PATH_SUFFIXES engine/include include)
    find_library(GR_DEBUG_LIBRARY graphite PATHS ENV SILGRAPHITE_HOME ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.3.1 ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.4.0 ${GR_GRAPHITE_DEBUG} ${PROJECT_SOURCE_DIR}/../../../graphite-trunk PATH_SUFFIXES engine/debug vs9/engine/src/Debug build/engine/src/Debug)
    find_library(GR_RELEASE_LIBRARY graphite PATHS ENV SILGRAPHITE_HOME ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.3.1 ${PROJECT_SOURCE_DIR}/../../../silgraphite-2.4.0 ${GR_GRAPHITE_RELEASE} ${PROJECT_SOURCE_DIR}/../../../graphite-trunk PATH_SUFFIXES engine/release vs9/engine/src/Release build/engine/src/Release)
    if (NOT GR_INCLUDE STREQUAL GR_INCLUDE-NOTFOUND)
		set(GR_FOUND 1)
		add_definitions(-DHAVE_GRAPHITE)
		set(GR_INCLUDE_DIRS ${GR_INCLUDE})
        set(GR_EXTRA_SOURCE GrUtfTextSrc.cpp)
    endif (NOT GR_INCLUDE STREQUAL GR_INCLUDE-NOTFOUND)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

include_directories(../common ${PROJECT_SOURCE_DIR}/../../src ${FREETYPE_INCLUDE_DIRS} ${HB_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS} ${GR_INCLUDE_DIRS} ${ICU_INCLUDE_DIRS} ${HB1_INCLUDE})

file(GLOB PRIVATE_HEADERS *.h) 
set_source_files_properties(${PRIVATE_HEADERS} PROPERTIES HEADER_FILE_ONLY true)

add_executable(comparerenderer
    CompareRenderer.cpp
    ${GR_EXTRA_SOURCE}
    ${ICULE}
    ${PRIVATE_HEADERS}
    )

# rt is for timing
target_link_libraries(comparerenderer graphite2-base graphite2 ${FREETYPE_LIBRARIES} ${GLIB_LD_FLAGS} ${HB_LDFLAGS} ${HB1_LDFLAGS} ${GR_LDFLAGS} ${ICU_LDFLAGS} ${RT_LDFLAGS})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	find_file(USP10_H NAMES Usp10.h)
	find_library(USP10_LIB NAMES Usp10.lib)
	if (NOT ${USP10_H} STREQUAL "USP10_H_NOTFOUND")
		add_definitions(-DHAVE_USP10)
	endif (NOT ${USP10_H} STREQUAL "USP10_H_NOTFOUND")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 iconv comparerenderer)
    if (${GR_FOUND})
        target_link_libraries(comparerenderer debug ${GR_DEBUG_LIBRARY})
        target_link_libraries(comparerenderer optimized ${GR_RELEASE_LIBRARY})
    endif (${GR_FOUND})
    if (NOT ${ICU_LIBRARY_PATH} STREQUAL "ICU_LIBRARY_PATH-NOTFOUND")
        file(GLOB ICU_DLLS ${ICU_LIBRARY_PATH}/*.dll)
        foreach(ICU_DLL ${ICU_DLLS})
	        add_custom_command(TARGET ${PROJECT_NAME}_copy_dll POST_BUILD
		        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${ICU_DLL} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})        
	    endforeach(ICU_DLL ${ICU_DLLS})
    endif (NOT ${ICU_LIBRARY_PATH} STREQUAL "ICU_LIBRARY_PATH-NOTFOUND")

endif  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

macro(comparetest TESTNAME FONTFILE TEXTFILE)
    if (${GR_FOUND})
    # comparision tests between old and new graphite
        add_test(NAME ${TESTNAME}_comparison COMMAND $<TARGET_FILE:comparerenderer>
        -t ${testing_SOURCE_DIR}/texts/${TEXTFILE} -f ${testing_SOURCE_DIR}/fonts/${FONTFILE} -s 12 -l ${PROJECT_BINARY_DIR}/${TESTNAME}_comparison.log -c -g -n --tolerance 0.0001 ${ARGN})
        add_test(NAME ${TESTNAME}_cached_comparison COMMAND $<TARGET_FILE:comparerenderer>
        -t ${testing_SOURCE_DIR}/texts/${TEXTFILE} -f ${testing_SOURCE_DIR}/fonts/${FONTFILE} -s 12 -l ${PROJECT_BINARY_DIR}/${TESTNAME}_cached_comparison.log -c -g -n --seg-cache 4096 --tolerance 0.0001 ${ARGN})
    endif (${GR_FOUND})
endmacro(comparetest)

comparetest(charis charis_r_gr.ttf udhr_eng.txt)
comparetest(padauk Padauk.ttf my_HeadwordSyllables.txt)
comparetest(padauk_ulon Padauk.ttf my_HeadwordSyllables.txt --features ulon=1)
comparetest(charis_yor charis_r_gr.ttf udhr_yor.txt)
comparetest(piglatin PigLatinBenchmark_v3.ttf udhr_eng.txt)
# comparerenderer needs a bidi algorithm before it can run this test
comparetest(scheherazade_arb Scheherazadegr.ttf udhr_arb.txt --rtl)
comparetest(annapurna_nep Annapurnarc2.ttf udhr_nep.txt)

# comparerenderer can also be used for font testing
install(TARGETS comparerenderer EXPORT comparerenderer RUNTIME DESTINATION bin)

=== tests/examples/CMakeLists.txt ===

project(testexamples)

include_directories(../../src)
INCLUDE(CheckTypeSize)

CHECK_TYPE_SIZE(size_t SIZEOF_SIZE_T)
add_definitions(-DSIZEOF_SIZE_T=${SIZEOF_SIZE_T})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
	add_dependencies(${PROJECT_NAME}_copy_dll graphite2 iconv simple features clusters linebreak)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

macro(test_example TESTNAME SRCFILE)
    add_executable(${TESTNAME} ${SRCFILE})
    set_target_properties(${TESTNAME} PROPERTIES LINKER_LANGUAGE C)
    target_link_libraries(${TESTNAME} graphite2)

    add_test(NAME ${TESTNAME} COMMAND $<TARGET_FILE:${TESTNAME}> ${ARGN})
endmacro(test_example)

test_example(simple simple.c ${testing_SOURCE_DIR}/fonts/Padauk.ttf "Hello World!")
test_example(features features.c ${testing_SOURCE_DIR}/fonts/Padauk.ttf)
test_example(clusters cluster.c ${testing_SOURCE_DIR}/fonts/Padauk.ttf "စက္ခုန္ဒြေ")
test_example(linebreak linebreak.c ${testing_SOURCE_DIR}/fonts/charis_r_gr.ttf 120 "This is a long test line that goes on and on and on")

=== tests/featuremap/CMakeLists.txt ===
project(featuremaptest)
include(Graphite)
include_directories(${graphite2_core_SOURCE_DIR})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 featuremaptest)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

set(S ${graphite2_core_SOURCE_DIR})
add_executable(featuremaptest featuremaptest.cpp)
target_link_libraries(featuremaptest graphite2 graphite2-base)

add_test(NAME featuremaptest COMMAND $<TARGET_FILE:featuremaptest> ${testing_SOURCE_DIR}/fonts/tiny.ttf)

=== tests/nametabletest/CMakeLists.txt ===
project(nametabletest)
include_directories(${graphite2_core_SOURCE_DIR})

add_executable(nametabletest nametabletest.cpp)
target_link_libraries(nametabletest graphite2-base)

add_test(NAME nametabletest COMMAND $<TARGET_FILE:nametabletest>)

=== tests/segcache/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
project(grsegcachetest)
include(Graphite)
include_directories(${graphite2_core_SOURCE_DIR})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 grsegcachetest)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")


set(S ${graphite2_core_SOURCE_DIR})
add_executable(grsegcachetest segcachetest.cpp)
target_link_libraries(grsegcachetest graphite2 graphite2-segcache graphite2-base)
    
add_test(NAME grsegcachetest COMMAND $<TARGET_FILE:grsegcachetest> ${testing_SOURCE_DIR}/fonts/Padauk.ttf)

=== tests/vm/CMakeLists.txt ===
project(vm-testing)
include(Graphite)

enable_testing()

include_directories(${graphite2_core_SOURCE_DIR})

set(S ${graphite2_core_SOURCE_DIR})

# I build the vm code here since it needs to be built for both code threading
# models rather than linking against the library from source.
add_library(vm-test-common STATIC 
    basic_test.cpp
    ${S}/Bidi.cpp 
    ${S}/Code.cpp 
    ${S}/CmapCache.cpp 
    ${S}/Face.cpp 
    ${S}/Pass.cpp
    ${S}/Segment.cpp
    ${S}/Silf.cpp)
target_link_libraries(vm-test-common graphite2 graphite2-base graphite2-segcache)

if  (${CMAKE_COMPILER_IS_GNUCXX})
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fomit-frame-pointer")
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -fomit-frame-pointer")
endif  (${CMAKE_COMPILER_IS_GNUCXX})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 vm-test-common)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

add_executable(vm-test-call ${S}/call_machine.cpp)
target_link_libraries(vm-test-call vm-test-common)

if  (${CMAKE_COMPILER_IS_GNUCXX})
	add_executable(vm-test-direct ${S}/direct_machine.cpp)
	target_link_libraries(vm-test-direct vm-test-common)
endif  (${CMAKE_COMPILER_IS_GNUCXX})


if  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	add_definitions(-fno-rtti -fno-exceptions)
	if ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
		add_definitions(-DNDEBUG -fomit-frame-pointer)
	endif ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
endif  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

add_test(vm-test-call-threading vm-test-call ${testing_SOURCE_DIR}/fonts/tiny.ttf 1)
set_tests_properties(vm-test-call-threading PROPERTIES
        PASS_REGULAR_EXPRESSION "simple program size:    14 bytes.*result of program: 42"
        FAIL_REGULAR_EXPRESSION "program terminated early;stack not empty")

if  (${CMAKE_COMPILER_IS_GNUCXX})
	add_test(vm-test-direct-threading vm-test-direct ${testing_SOURCE_DIR}/fonts/tiny.ttf 1)
	set_tests_properties(vm-test-direct-threading PROPERTIES
			PASS_REGULAR_EXPRESSION "simple program size:    14 bytes.*result of program: 42"
			FAIL_REGULAR_EXPRESSION "program terminated early;stack not empty")
endif  (${CMAKE_COMPILER_IS_GNUCXX})

=== debian/changelog ===
graphite2 (1.1.3-1) unstable; urgency=low

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Sat, 02 Jun 2012 01:10:10 +0200

graphite2 (1.1.2-1) unstable; urgency=low

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Fri, 20 Apr 2012 01:45:47 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=build

override_dh_strip:
	dh_strip --dbg-package=libgraphite2-2.0.0-dbg

override_dh_auto_build:
	dh_auto_build
	echo "Building docs"
	dh_auto_build -- docs
#	echo "Building perl module"
#	cd perl && \
#		perl Build.PL prefix=/usr && \
#		./Build

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/bin
#	cd perl && \
#		./Build install destdir=$(CURDIR)/debian/libtext-graphite2-perl
#	# hack
#	cd $(CURDIR)/debian/libtext-graphite2-perl/usr && \
#		mkdir share && mv man share
#	cd $(CURDIR)/debian/libtext-graphite2-perl/usr/lib && \
#		mv perl perl5 && cd perl5 && mv 5.*/* . && rm -rf 5.*
#	find debian/libtext-graphite2-perl -type f -name .packlist | xargs rm -f

override_dh_auto_test:
	dh_auto_test
#ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#	cd perl && \
#		LD_LIBRARY_PATH=$(CURDIR)/build/src ./Build test
#endif

override_dh_auto_clean:
#	if [ -e perl/Build ]; then cd perl && \
#		./Build clean; fi
#	rm -rf perl/Build perl/_build
	-find . -name "CTestCostData.txt" | xargs rm
	-find . -name "LastTest.log"  | xargs rm
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DGRAPHITE2_NTRACING:bool=1 -DGRAPHITE2_COMPARE_RENDERER=ON -DICU_LIBRARY_PATH=/usr/lib

override_dh_gencontrol:
	dh_gencontrol -Nlibtext-graphite2-perl -O--builddirectory=build
#	dh_gencontrol -plibtext-graphite2-perl -- -v`cat perl/META.yml | grep version: | tail -n 1 | awk '{ print $$2 }'`-`dpkg-parsechangelog  | grep urgency | awk '{ print $$2 }' | sed -e 's/(//' | sed -e 's/)//' | cut -d- -f2`

## graphite2 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,18 @@
 if (NOT CMAKE_BUILD_TYPE)
     set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
 endif (NOT CMAKE_BUILD_TYPE)
+#if (CMAKE_BUILD_TYPE STREQUAL ClangASN)
+#    add_definitions(-faddress-sanitizer -fno-omit-frame-pointer)
+#    set_property(CACHE CMAKE_C_COMPILER PROPERTY VALUE clang)
+#    set_property(CACHE CMAKE_CXX_COMPILER PROPERTY VALUE clang)
+#endif (CMAKE_BUILD_TYPE STREQUAL ClangASN)
 
 enable_language(CXX C)
 
 include_directories(${PROJECT_SOURCE_DIR}/include)
+if (CMAKE_BUILD_TYPE STREQUAL ClangASN)
+    add_definitions(-faddress-sanitizer -fno-omit-frame-pointer)
+endif (CMAKE_BUILD_TYPE STREQUAL ClangASN)
 
 enable_testing()
 
@@ -48,7 +56,6 @@
 endif (GRAPHITE2_VM_TYPE STREQUAL "direct" AND NOT (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_BASE_NAME STREQUAL "clang++"))
 message(STATUS "Using vm machine type: ${GRAPHITE2_VM_TYPE}")
 
-
 add_subdirectory(src)
 add_subdirectory(tests)
 add_subdirectory(doc)

=== src/CMakeLists.txt ===
#    GRAPHITE2 LICENSING
#
#    Copyright 2010, SIL International
#    All rights reserved.
#
#    This library is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation; either version 2.1 of License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should also have received a copy of the GNU Lesser General Public
#    License along with this library in the file named "LICENSE".
#    If not, write to the Free Software Foundation, 51 Franklin Street, 
#    Suite 500, Boston, MA 02110-1335, USA or visit their web page on the 
#    internet at http://www.fsf.org/licenses/lgpl.html.

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
project(graphite2_core)
cmake_policy(SET CMP0012 NEW)
INCLUDE(CheckCXXSourceCompiles)

set(GRAPHITE_API_CURRENT 3)
set(GRAPHITE_API_REVISION 0)
set(GRAPHITE_API_AGE 1)
set(GRAPHITE_VERSION ${GRAPHITE_API_CURRENT}.${GRAPHITE_API_REVISION}.${GRAPHITE_API_AGE})
set(GRAPHITE_SO_VERSION ${GRAPHITE_API_CURRENT})

include(TestBigEndian)

include_directories(${PROJECT_SOURCE_DIR})

set(SEGCACHE SegCache.cpp SegCacheEntry.cpp SegCacheStore.cpp)
if (GRAPHITE2_NSEGCACHE)
    add_definitions(-DGRAPHITE2_NSEGCACHE)
    set(SEGCACHE)
endif (GRAPHITE2_NSEGCACHE)

set(FILEFACE FileFace.cpp)
if (GRAPHITE2_NFILEFACE)
    add_definitions(-DGRAPHITE2_NFILEFACE)
    set(FILEFACE)
endif (GRAPHITE2_NFILEFACE)

set(TRACING json.cpp)
if (GRAPHITE2_NTRACING)
    add_definitions(-DGRAPHITE2_NTRACING)
    set(TRACING)
endif (GRAPHITE2_NTRACING)


set(GRAPHITE_HEADERS 
    ../include/graphite2/Font.h
    ../include/graphite2/Segment.h
    ../include/graphite2/Types.h
    ../include/graphite2/Log.h
    )

file(GLOB PRIVATE_HEADERS inc/*.h) 

add_library(graphite2 SHARED
    ${GRAPHITE2_VM_TYPE}_machine.cpp
    gr_char_info.cpp
    gr_features.cpp
    gr_face.cpp
    gr_font.cpp
    gr_logging.cpp
    gr_segment.cpp
    gr_slot.cpp
    Bidi.cpp
    CachedFace.cpp
    CmapCache.cpp
    Code.cpp
    Face.cpp
    FeatureMap.cpp
    Font.cpp
    GlyphFace.cpp
    GlyphCache.cpp
    Justifier.cpp
    NameTable.cpp
    Pass.cpp
    Rule.cpp
    Segment.cpp
    Silf.cpp
    Slot.cpp
    Sparse.cpp
    TtfUtil.cpp
    UtfCodec.cpp
    ${FILEFACE}
    ${SEGCACHE}
    ${TRACING})

set_target_properties(graphite2 PROPERTIES  PUBLIC_HEADER "${GRAPHITE_HEADERS}"
                                            SOVERSION ${GRAPHITE_SO_VERSION}
                                            VERSION ${GRAPHITE_VERSION}
                                            LT_VERSION_CURRENT ${GRAPHITE_API_CURRENT}
                                            LT_VERSION_REVISION ${GRAPHITE_API_REVISION}
                                            LT_VERSION_AGE ${GRAPHITE_API_AGE})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set_target_properties(graphite2 PROPERTIES 
        COMPILE_FLAGS   "-Wall -Wextra -Wno-unknown-pragmas -Wendif-labels -Wshadow -Wctor-dtor-privacy -Wnon-virtual-dtor -fdiagnostics-show-option -fno-rtti -fno-exceptions -fvisibility=hidden -fvisibility-inlines-hidden -fno-stack-protector"
        LINK_FLAGS      "-nodefaultlibs" 
        LINKER_LANGUAGE C)
    if (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
        target_link_libraries(graphite2 kernel32 msvcr90 mingw32 gcc user32)
    else (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
        target_link_libraries(graphite2 c gcc)
        include(Graphite)
        nolib_test(stdc++ $<TARGET_SONAME_FILE:graphite2>)
    endif (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
    set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
    CREATE_LIBTOOL_FILE(graphite2 "/lib${LIB_SUFFIX}")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    set_target_properties(graphite2 PROPERTIES 
        COMPILE_FLAGS   "-Wall -Wextra -Wno-unknown-pragmas -Wendif-labels -Wshadow -Wno-ctor-dtor-privacy -Wno-non-virtual-dtor -fdiagnostics-show-option -fno-rtti -fno-exceptions -fvisibility=hidden -fvisibility-inlines-hidden -fno-stack-protector"
        LINK_FLAGS      "-nodefaultlibs" 
        LINKER_LANGUAGE C)
    target_link_libraries(graphite2 c)
    include(Graphite)
    nolib_test(stdc++ $<TARGET_SONAME_FILE:graphite2>)
    set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
    CREATE_LIBTOOL_FILE(graphite2 "/lib${LIB_SUFFIX}")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set_target_properties(graphite2 PROPERTIES 
        COMPILE_DEFINITIONS "_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE;GRAPHITE2_EXPORTING")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")


install(TARGETS graphite2 EXPORT graphite2 LIBRARY DESTINATION lib${LIB_SUFFIX} ARCHIVE DESTINATION lib${LIB_SUFFIX} PUBLIC_HEADER DESTINATION include/graphite2 RUNTIME DESTINATION bin)
install(EXPORT graphite2 DESTINATION share/graphite2 NAMESPACE gr2_)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -15,25 +15,39 @@
     ${S}/UtfCodec.cpp)
 
 add_library(graphite2-segcache STATIC
-    ${S}/GlyphFaceCache.cpp
+    ${S}/Bidi.cpp
+    ${S}/call_machine.cpp
+    ${S}/Code.cpp
+    ${S}/CmapCache.cpp
+    ${S}/Face.cpp
+    ${S}/FileFace.cpp
+    ${S}/GlyphCache.cpp
     ${S}/GlyphFace.cpp
-    ${S}/gr_logging.cpp
-    ${S}/json.cpp
+    ${S}/Pass.cpp
+    ${S}/Rule.cpp
     ${S}/SegCache.cpp
     ${S}/SegCacheEntry.cpp
-    ${S}/SegCacheStore.cpp
-    ${S}/Slot.cpp)
+    ${S}/Segment.cpp
+    ${S}/Silf.cpp
+    ${S}/Slot.cpp
+    )
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
     set_target_properties(graphite2-base PROPERTIES 
-                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC _SCL_SECURE_NO_WARNINGS _CRT_SECURE_NO_WARNINGS UNICODE")
+                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE")
     set_target_properties(graphite2-segcache PROPERTIES 
-                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC _SCL_SECURE_NO_WARNINGS _CRT_SECURE_NO_WARNINGS UNICODE")
+                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE")
 else (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
     set_target_properties(graphite2-base PROPERTIES 
-                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
+        COMPILE_FLAGS       "-Wall -Wextra -fdiagnostics-show-option -fno-rtti -fno-exceptions -fno-stack-protector"
+        COMPILE_DEFINITIONS "GRAPHITE2_STATIC"
+        LINK_FLAGS          "-nodefaultlibs" 
+        LINKER_LANGUAGE     C)
     set_target_properties(graphite2-segcache PROPERTIES 
-                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
+        COMPILE_FLAGS       "-Wall -Wextra -fdiagnostics-show-option -fno-rtti -fno-exceptions -fno-stack-protector"
+        COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING"
+        LINK_FLAGS          "-nodefaultlibs" 
+        LINKER_LANGUAGE     C)
 endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
 
 if (GRAPHITE2_COMPARE_RENDERER)
@@ -50,10 +64,12 @@
 if (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
     add_subdirectory(segcache)
 endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
+add_subdirectory(sparsetest)
 add_subdirectory(utftest)
 if (NOT GRAPHITE2_NFILEFACE)
     add_subdirectory(vm)
 endif (NOT GRAPHITE2_NFILEFACE)
+add_subdirectory(fuzz-tests)
 
 enable_testing()
 
@@ -77,6 +93,7 @@
 fonttest(charis3 charis_r_gr.ttf 0054 0069 1ec3 0075 -feat 'lang=vie')
 fonttest(charis4 charis_r_gr.ttf 006b 0361 070)
 fonttest(charis5 charis_r_gr.ttf 0020 006C 0325 0065)
+fonttest(charis6 charis_r_gr.ttf 0048 0065 006C 006C 006F 0020 004D 0075 006D -j 107)
 fonttest(magyar1 MagyarLinLibertineG.ttf 0031 0035 -feat 210=36)
 fonttest(magyar2 MagyarLinLibertineG.ttf 0031 0030 -feat 210=200)
 fonttest(magyar3 MagyarLinLibertineG.ttf 0066 0069 0066 0074 0079 002d 0066 0069 0076 0065 -feat 209=3)

=== tests/fuzz-tests/CMakeLists.txt ===
project(fuzztesting)

function(trimtail VAR RESULT)
    STRING(REGEX MATCH "[^/]+$" trimtail_result ${${VAR}})
    set(${RESULT} ${trimtail_result} PARENT_SCOPE)
    STRING(REGEX REPLACE "^(.*)/[^/]+$" "\\1" trimtail_remainder ${${VAR}})
    set(${VAR} ${trimtail_remainder} PARENT_SCOPE)
endfunction(trimtail)

add_custom_target(fuzztest)
file(GLOB_RECURSE tfiles RELATIVE ${PROJECT_SOURCE_DIR} *.fuzz)
set(lastfontname "")
foreach (tfile IN LISTS tfiles)
    set(tpath ${tfile})
    trimtail(tpath tname)
    trimtail(tpath textname)
    trimtail(tpath fname)
    if (NOT lastfontname EQUAL fname)
        add_custom_command(TARGET fuzztest PRE_BUILD COMMAND echo ${fname})
        set(lastfontname ${fname})
    endif(NOT lastfontname EQUAL fname)
    add_custom_command(TARGET fuzztest PRE_BUILD COMMAND ${PROJECT_SOURCE_DIR}/../fuzztest ARGS -l fuzzregress-${fname}-${textname}-${tname}.log -f ${PROJECT_SOURCE_DIR}/../fonts/${fname}.ttf -t 10 -q --memory=200 --include=required,graphite --exclude==fontdir,opentype,volt,advtypo,post --valgrind --input=${PROJECT_SOURCE_DIR}/${fname}/${textname}/${tname} -- ../comparerenderer/comparerenderer -q -s 12 -n -f {} -t ${PROJECT_SOURCE_DIR}/texts/${textname}.txt)
    add_custom_command(TARGET fuzztest POST_BUILD COMMAND perl ARGS -e 'print"$$ARGV[0] Failed\\n" if(-s $$ARGV[0])' fuzzregress-${fname}-${textname}-${tname}.log)
endforeach(tfile)

=== tests/segcache/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,8 @@
 
 set(S ${graphite2_core_SOURCE_DIR})
 add_executable(grsegcachetest segcachetest.cpp)
+set_target_properties(grsegcachetest PROPERTIES COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
 target_link_libraries(grsegcachetest graphite2 graphite2-segcache graphite2-base)
     
 add_test(NAME grsegcachetest COMMAND $<TARGET_FILE:grsegcachetest> ${testing_SOURCE_DIR}/fonts/Padauk.ttf)
+set_tests_properties(grsegcachetest PROPERTIES TIMEOUT 3)

=== debian/changelog ===
graphite2 (1.2.0-3) experimental; urgency=low

  * apply patch from Daniel Schaal to convert to multiarch
    as already multiarchified pango now needs us via harfbuzz...
    (closes: #699714)
  * clean up (not packaged) perl module packaging
  * add (not used yet) stuff to build mono binding
  * split arch-dep and arch-indep (docs...) build
  * disable the compare renderer stuff - enough compared ;-)

 -- Rene Engelhard <rene@debian.org>  Wed, 27 Feb 2013 20:24:34 +0100

graphite2 (1.2.0-2) experimental; urgency=low

  * break libgraphite2-2.0.0 (<< 1.2.0) (closes: #689813)

 -- Rene Engelhard <rene@debian.org>  Sat, 06 Oct 2012 18:24:32 +0200

graphite2 (1.2.0-1) experimental; urgency=low

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Fri, 21 Sep 2012 16:41:23 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --builddirectory=build

override_dh_strip:
	dh_strip --dbg-package=libgraphite2-3-dbg

override_dh_auto_build-arch:
	dh_auto_build
#	echo "Building perl module"
#	cd contrib/perl && \
#		perl Build.PL prefix=/usr && \
#		./Build

override_dh_auto_build-indep:
	echo "Building docs"
	dh_auto_build -- docs
#	echo "Building C# binding"
#	cd contrib/C\# && \
#		mono-xbuild NGraphite.sln

override_dh_auto_install:
	dh_auto_install
#	cd perl && \
#		./Build install destdir=$(CURDIR)/debian/libtext-gr2-perl
#	# hack
#	cd $(CURDIR)/debian/libtext-gr2-perl/usr && \
#		mkdir share && mv man share
#	cd $(CURDIR)/debian/libtext-gr2-perl/usr/lib && \
#		mv perl perl5 && cd perl5 && mv 5.*/* . && rm -rf 5.*
#	find debian/libtext-gr2-perl -type f -name .packlist | xargs rm -f

override_dh_auto_test:
	dh_auto_test
#ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#	cd contrib/perl && \
#		LD_LIBRARY_PATH=$(CURDIR)/build/src ./Build test
#endif

override_dh_auto_clean:
#	if [ -e contrib/perl/Build ]; then cd contrib/perl && \
#		./Build clean; fi
#	rm -rf contrib/perl/Build contrib/perl/_build
#	rm -f /contrib/perl/MYMETA*
#	rm -f contrib/C\#/NGraphite/obj/Debug/NGraphite.csproj.FilesWrittenAbsolute.txt
#	-find contrib/C\# -name "*.dll" | xargs rm
#	-find contrib/C\# -name "*.dll.mdb" | xargs rm
	-find . -name "CTestCostData.txt" | xargs rm
	-find . -name "LastTest.log"  | xargs rm
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DGRAPHITE2_NTRACING:bool=1 -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

override_dh_gencontrol:
	dh_gencontrol -Nlibtext-gr2-perl -O--builddirectory=build
#	dh_gencontrol -plibtext-gr2-perl -- -v`cat perl/META.yml | grep version: | tail -n 1 | awk '{ print $$2 }'`-`dpkg-parsechangelog  | grep urgency | awk '{ print $$2 }' | sed -e 's/(//' | sed -e 's/)//' | cut -d- -f2`

## graphite2 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -63,7 +63,7 @@
     add_subdirectory(gr2fonttest)
 endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
 
-set(version 2.1.0)
+set(version 3.0.1)
 set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
 set(includedir ${CMAKE_INSTALL_PREFIX}/include)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -39,12 +39,12 @@
                             COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE")
 else (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
     set_target_properties(graphite2-base PROPERTIES 
-        COMPILE_FLAGS       "-Wall -Wextra -fdiagnostics-show-option -fno-rtti -fno-exceptions -fno-stack-protector"
+        COMPILE_FLAGS       "-Wall -Wextra -fno-rtti -fno-exceptions -fno-stack-protector"
         COMPILE_DEFINITIONS "GRAPHITE2_STATIC"
         LINK_FLAGS          "-nodefaultlibs" 
         LINKER_LANGUAGE     C)
     set_target_properties(graphite2-segcache PROPERTIES 
-        COMPILE_FLAGS       "-Wall -Wextra -fdiagnostics-show-option -fno-rtti -fno-exceptions -fno-stack-protector"
+        COMPILE_FLAGS       "-Wall -Wextra -fno-rtti -fno-exceptions -fno-stack-protector"
         COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING"
         LINK_FLAGS          "-nodefaultlibs" 
         LINKER_LANGUAGE     C)

=== debian/changelog ===
graphite2 (1.2.1-1) experimental; urgency=low

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Mon, 04 Mar 2013 19:44:28 +0100

graphite2 (1.2.0-4) experimental; urgency=low

  * revert multiarch stuff as harfbuzz now doesn't need us
    anymore... (reopens: #699714) 

 -- Rene Engelhard <rene@debian.org>  Sat, 02 Mar 2013 14:29:58 +0100

=== debian/control ===
Source: graphite2
Priority: optional
Section: libs
Maintainer: Debian LibreOffice Team <debian-openoffice@lists.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>, Daniel Glassey <wdg@debian.org>
Build-Depends: debhelper (>= 9), cmake, libfreetype6-dev
# perl: libmodule-build-perl
# mono: mono-xbuild, mono-gmcs, mono-dmcs, libnunit-cil-dev
Build-Depends-Indep: asciidoc, dblatex, doxygen, docbook-xsl, latex-xcolor, libxml2-utils
Standards-Version: 3.9.1

Package: libgraphite2-3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libgraphite2-2.0.0
Replaces: libgraphite2-2.0.0
Breaks: libgraphite2-2.0.0 (<< 1.2.0)
Description: Font rendering engine for Complex Scripts -- library
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .  
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 This package contains the shared library.

Package: libgraphite2-dev
Section: libdevel
Architecture: any
Depends: libgraphite2-3 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libgraphite2
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 This package contains the development libraries for libgraphite2 

Package: libgraphite2-3-dbg
Priority: extra
Section: debug
Architecture: any
Depends: libgraphite2-3 (= ${binary:Version}), ${misc:Depends}
Description: Debug symbols for libgraphite2
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 Debug symbols for libgraphite2

Package: libgraphite2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for libgraphite2
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 PDF and HTML documentation for libgraphite2

#Package: libtext-gr2-perl
#Section: perl
#Architecture: any
#Depends: ${shlibs:Depends}, perl, ${perl:Depends}, ${misc:Depends}
#Description: Perl Interface to SIL's Graphite2 rendering engine
# Graphite is a system that can be used to create and use "smart fonts" capable
# of displaying writing systems with various complex behaviors, such as:
# contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
# stacking diacritics and complex positioning.
# .
# This library was designed and developed by the NRSI (Non-Roman Script
# Initiative) within SIL International (www.sil.org) to act as a complement to
# other smart font rendering technologies with limited practical local
# extensibility. Its purpose is to help meet the needs of a very large number
# of "minority language" communities for local extensibility of complex script
# behaviors.
# .
# The behavior of the rendering engine for a given writing system is specified
# through extra tables added to a TrueType font.  These tables are generated by
# compiling a GDL (Graphite Description Language) source file into a font using
# grcompiler.
# .
# This package contains the Text::Graphite2 module.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-include /usr/share/dpkg/architecture.mk
 
 %:
 	dh $@ --builddirectory=build
@@ -53,7 +51,7 @@
 	dh_auto_clean
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DGRAPHITE2_NTRACING:bool=1 -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DGRAPHITE2_NTRACING:bool=1
 
 override_dh_gencontrol:
 	dh_gencontrol -Nlibtext-gr2-perl -O--builddirectory=build

## graphite2 1.2.3

=== debian/changelog ===
graphite2 (1.2.3-1) unstable; urgency=low

  * New upstream release

 -- Rene Engelhard <rene@debian.org>  Tue, 11 Jun 2013 19:25:25 +0200

graphite2 (1.2.2-2) unstable; urgency=low

  * add patch from Michael Cree <mcree@orcon.net.nz> to fix
    misaligned memory access - thanks (closes: #710336) 

 -- Rene Engelhard <rene@debian.org>  Sun, 02 Jun 2013 12:05:28 +0000

graphite2 (1.2.2-1) unstable; urgency=low

  * New upstream release
  * stop building with -O3 gotten from somewhere and overriding
    dpkg-buildflags' value, just remove  via sed
  * converto multiarch again... (closes: #689813)

 -- Rene Engelhard <rene@debian.org>  Fri, 31 May 2013 18:10:55 +0200

graphite2 (1.2.1-2) unstable; urgency=low

  * upload to unstable 

 -- Rene Engelhard <rene@debian.org>  Thu, 18 Apr 2013 23:49:24 +0200
